"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getArgs = void 0;
const yargs_1 = __importDefault(require("yargs"));
const getArgs = () => yargs_1.default
    .scriptName("suppress-ts-errors")
    .usage("$0 -p <path to tsconfig.json> -c <comment type>")
    .options({
    "tsconfig-path": {
        type: "string",
        default: "./tsconfig.json",
        alias: "p",
        describe: "Path to tsconfig.json",
        demandOption: true,
    },
    "comment-type": {
        choices: [1, 2],
        default: 1,
        alias: "t",
        describe: "Choice of comment type. 1 is @ts-expected-error, 2 is @ts-ignore. default is 1",
        demandOption: true,
    },
    "with-error-code": {
        type: "boolean",
        default: true,
        alias: "c",
        demandOption: true,
        describe: "Add error code to comment. e.g. TS2345.",
    },
    vue: {
        type: "string",
        describe: "glob pattern path for Vue files, set if vue SFC is the target for adding comments",
    },
})
    .help()
    .alias({ h: "help", v: "version" })
    .parseSync();
exports.getArgs = getArgs;
